#include "hud.h"
#include "cl_util.h"
#include "vgui_TeamFortressViewport.h"
#include "MOD_vguiTaskPanel.h"
#include "triangleapi.h"
#include <../game_shared/vgui_loadtga.h>
#include "../tinyxml/tinyxml.h"
#pragma comment (lib,"tinyxml.lib")
#include "ammohistory.h"
/* BACKPACK SLOT */
CMODInventorySlotBackpack::CMODInventorySlotBackpack(int w, int h) : CMODInventorySlotBase(INV_SLK_BACKPACK,INV_ACT_ITEM_WAITS_ACTION)
{
	setSize(w,h);
}
bool CMODInventorySlotBackpack::AssignSlot(char *szwn, int iid, int spf)
{
	char sz[255];
	sprintf(sz,"added weapon is %s\n",szwn);
	gEngfuncs.pfnConsolePrint(sz);
	if (!GetParentInv()->GetItemSPictInfo(szwn)) return false; else
	{
	m_pszItemName = szwn;
	m_iId = iid;
	m_iSpecialFlags = spf;
    return true;
	};
}
BitmapTGA* CMODInventorySlotBackpack::ReturnSlotPicture(int slp)
{
	switch(slp)
	{
		case SLP_ITEM:
			if (m_pszItemName) return GetParentInv()->GetItemSPictInfo(m_pszItemName); else return NULL;
			break;
		case SLP_DESC:
			if (m_pszItemName) return GetParentInv()->GetItemDPictInfo(m_pszItemName); else return NULL;
			break;
	};
}

void CMODInventorySlotBackpack::paint()
{
	drawSetColor(100, 100, 200, 100);
	BitmapTGA* slp = ReturnSlotPicture(SLP_ITEM);
	if (slp) slp->doPaint(this); else drawFilledRect(0,0,getWide(),getTall());
	if (m_iPaintFlags & IPF_YELLOWRECT)
	{
		drawSetColor(255, 255, 0, 0);
		drawOutlinedRect(0,0,getWide(),getTall());
	};
}
void CMODInventorySlotBackpack::internalCursorEntered() { GetParentInv()->SetDescriptionImage(ReturnSlotPicture(SLP_DESC)); };
void CMODInventorySlotBackpack::internalCursorExited()	{ GetParentInv()->SetDescriptionImage(NULL); };
void CMODInventorySlotBackpack::internalMousePressed(vgui::MouseCode code)
{
	// there are we checking previous buttons
	switch (GetParentInv()->GetCurrentKind())
	{
	case INV_SLK_NULL:
	case INV_SLK_BACKPACK:
		SetSelectionFrame();
		GetParentInv()->SetCurrentButton(this);
		break;
	case INV_SLK_HOTKEY:
		if (GetParentInv()->GetCurrentButton()->ReturnSlotItemName() == ReturnSlotItemName())
			GetParentInv()->GetCurrentButton()->ClearSlot();
		else
			GetParentInv()->GetCurrentButton()->AssignSlot(this);
		break;
	case INV_SLK_BUT_EQUIP:
		GetParentInv()->SetCurrentButton(this);
		GetParentInv()->ButtonActionEquipUse();
		GetParentInv()->HideInventory();
		break;
	case INV_SLK_BUT_DROP:
		GetParentInv()->SetCurrentButton(this);
		GetParentInv()->ButtonActionDrop();
		GetParentInv()->HideInventory();
		break;
		

	};
	
	//char sz[255]; sprintf(sz,"CurrentState\nActiveButtonKind:%i",GetParentInv()->GetCurrentKind()); gEngfuncs.pfnConsolePrint(sz);
};
/* BACKPACK END */
/* QUICKSLOT START */
CMODInventorySlotQuick::CMODInventorySlotQuick(int w, int h) : CMODInventorySlotBase(INV_SLK_HOTKEY,INV_ACT_HOTK_WAITS_ITEM)
{
	setSize(w,h);
	m_bLinkTo = NULL;
}
bool CMODInventorySlotQuick::AssignSlot(CMODInventorySlotBase *bb, bool doForce)
{
	//if (!doForce) { if (bb->IsSlotEmpty()) return false; };
	if (bb->IsSlotEmpty()) gEngfuncs.pfnConsolePrint("slot is empty\n");
	gEngfuncs.pfnConsolePrint("WE ARE ASSIGNING A SLOT\n");
	m_bLinkTo = (CMODInventorySlotBackpack*)bb;
	return true;
}
void CMODInventorySlotQuick::paint()
{
	drawSetColor(100, 100, 200, 100);
	BitmapTGA* slp = ReturnSlotPicture(SLP_ITEM);
	if (slp) slp->doPaint(this); else drawFilledRect(0,0,getWide(),getTall());
	if (m_iPaintFlags & IPF_GREENRECT)
	{
		drawSetColor(0, 255, 0, 0);
		drawOutlinedRect(0,0,getWide(),getTall());
	};
}
void CMODInventorySlotQuick::internalMousePressed(vgui::MouseCode code)
{
	switch (GetParentInv()->GetCurrentKind())
	{
	case INV_SLK_NULL:
	case INV_SLK_HOTKEY:
		SetSelectionFrame();
		GetParentInv()->SetCurrentButton(this);
		break;
	case INV_SLK_BACKPACK:
		if (GetParentInv()->GetCurrentButton()->ReturnSlotItemName() == ReturnSlotItemName()) 
			ClearSlot(); 
		else
			AssignSlot(GetParentInv()->GetCurrentButton());
		break;
	//there are no other actions for buttons
	}
}
/* QUICKSLOT END */
/* BUTTONS START */
CMODInventorySlotButton::CMODInventorySlotButton(int k,int c) : CMODInventorySlotBase(k,c)
{
	setSize(k,c);
}
void CMODInventorySlotButton::paint()
{
	if (m_iPaintFlags & IPF_REDRECT)
	{
		drawSetColor(255, 0, 0, 0);
		drawOutlinedRect(0,0,getWide(),getTall());
	}
}



/* BUTTONS END */
CMODTaskPanel::CMODTaskPanel(int x, int y, int wide, int tall) : Panel(x,y,wide,tall)
{
	//setPaintBackgroundEnabled(false);
	if (m_pBackground) return;
	setBgColor(0,0,0,0);
	m_pBackground = vgui_LoadTGA("gfx/vgui/backgroundtoall.tga");
	m_pInvBackground = vgui_LoadTGA("gfx/vgui/640_inventory.tga");
	int zx,zy;
	m_pBackground->getSize(zx,zy);
	m_pBackground->setPos((ScreenWidth-zx)/2,(ScreenHeight-zy)/2);
	m_pInvBackground->getSize(zx,zy);
	m_pInvBackground->setPos((ScreenWidth-zx)/2,(ScreenHeight-zy)/2);
	setSize(ScreenWidth,ScreenHeight);
	setPos(0,0);
	int top = (ScreenHeight/2-zy/2)+73; int left = (ScreenWidth/2-zx/2) + 36;
	//CMODInventorySlot* mislot = new CMODInventorySlot("",left,top,99,99,false,true);
	for (int i=0; i< 3; i++)
	{
		m_vBackpackSlots.push_back(new CMODInventorySlotBackpack(99,99));
		m_vBackpackSlots[i]->setParent(this);
		m_vBackpackSlots[i]->setVisible(true);
		m_vBackpackSlots[i]->SetIntNum(i);
		m_vBackpackSlots[i]->SetPos(left,top);
		left+=99+3;
	};
	top = (ScreenHeight/2-zy/2)+231; left = (ScreenWidth/2-zx/2) + 36;
	for (int i=3; i < 6; i++)
	{
		m_vBackpackSlots.push_back(new CMODInventorySlotBackpack(99,99));
		m_vBackpackSlots[i]->setParent(this);
		m_vBackpackSlots[i]->setVisible(true);
		m_vBackpackSlots[i]->SetIntNum(i);
		m_vBackpackSlots[i]->SetPos(left,top);
		left+=99+3;
	};
	top = (ScreenHeight/2-zy/2)+73; left = (ScreenWidth/2-zx/2) + 403;
	for (int i=0; i< 3; i++)
	{
		m_vQuickSlots.push_back(new CMODInventorySlotQuick(99,99));
		m_vQuickSlots[i]->setParent(this);
		m_vQuickSlots[i]->setVisible(true);
		m_vQuickSlots[i]->SetIntNum(i);
		m_vQuickSlots[i]->SetPos(left,top);
		left+=99+3;
	};
	top = (ScreenHeight/2-zy/2)+ 226; left = (ScreenWidth/2-zx/2) + 373;
	for (int i=0; i<5 ; i++)
	{
		m_vActionButtons.push_back(new CMODInventorySlotButton(INV_SLK_BUT_EQUIP + i,INV_ACT_COMD_WAITS_EQUIP + i));
		m_vActionButtons[i]->setParent(this);
		m_vActionButtons[i]->setVisible(true);
		m_vActionButtons[i]->SetIntNum(i);
		m_vActionButtons[i]->SetPos(left,top);
		top+=47+3;
	}
	m_pItemImage = new ImagePanel();
	m_pItemImage->setPos((ScreenWidth/2-zx/2)+36,(ScreenHeight/2-zy/2)+353);
	m_pItemImage->setSize(302,98);
	m_pItemImage->setParent(this);
	m_pItemImage->setVisible(true);
	LoadInventoryXml();
}

void CMODTaskPanel::paint()
{
	m_pBackground->doPaint(this);
	m_pInvBackground->doPaint(this);
}

bool CMODTaskPanel::LoadInventoryXml()
{
	char fl[255] = "xml/inventory_items.xml";
	char *pfile = (char*)gEngfuncs.COM_LoadFile(fl,5,NULL);
	if (!pfile) { gEngfuncs.pfnConsolePrint("mod_inventory: can not load inventory items description \n"); return 0; };
	char *ptext = pfile;
	TiXmlDocument base_xml;
	//gEngfuncs.pfnConsolePrint(ptext);
	base_xml.Parse(ptext);
	gEngfuncs.COM_FreeFile(pfile);
	TiXmlHandle base_xml_handle(&base_xml), hRoot(0);
	TiXmlElement *pElem;
    pElem = base_xml_handle.FirstChildElement("root").ToElement();
	if (!pElem)
	{
		gEngfuncs.pfnConsolePrint("mod_inventory: can not find root node ROOT in inventory_items.xml");
		return 0;
	};
	for (pElem=pElem->FirstChild()->ToElement();pElem;pElem=pElem->NextSiblingElement())
	{
		s_inv_item* s = (s_inv_item*)malloc(sizeof(s_inv_item));
		sprintf(s->pszItemName,"%s",pElem->Value());
		//gEngfuncs.pfnConsolePrint(s->pszItemName);
		s->pDescPicture = vgui_LoadTGA((char*)pElem->FirstChildElement("desc")->ToElement()->GetText());
		s->pInvSlotPict = vgui_LoadTGA((char*)pElem->FirstChildElement("slot")->ToElement()->GetText());
		m_vItemDescription.push_back(s);
	}
	return 1;
};

int CMODTaskPanel::GetFreeSlot()
{
	int freesl = -1;
	for (int i=0;i<6;i++)
		if (m_vBackpackSlots[i]->IsSlotEmpty()) { freesl=i;break; };
	return freesl;
}

bool CMODTaskPanel::AddItem(char *szItemName, int itk, int fl, int id)
{
	int free_slot = GetFreeSlot();
	if (free_slot<0) return 0;
	gEngfuncs.pfnConsolePrint("weapon addinv is "); gEngfuncs.pfnConsolePrint(szItemName);
	return m_vBackpackSlots[free_slot]->AssignSlot(szItemName, id, fl/*, itk*/);
}
bool CMODTaskPanel::SelectSlot(int i)
{
	if (i<3)
		if (!m_vQuickSlots[i]->IsSlotEmpty()) 
		{
			gEngfuncs.pfnClientCmd(m_vQuickSlots[i]->ReturnSlotItemName());
			m_pszCurrentSelectedHotkeyItem = m_vQuickSlots[i]->ReturnSlotItemName();
		};
	return 1;
}
BitmapTGA* CMODTaskPanel::GetItemDPictInfo(char *szItemName)
{
	for (int i=0;i<m_vItemDescription.size();i++)
		if (!strcmp(m_vItemDescription[i]->pszItemName,szItemName)) return m_vItemDescription[i]->pDescPicture;
	return NULL;
}
BitmapTGA* CMODTaskPanel::GetItemSPictInfo(char *szItemName)
{
	for (int i=0;i<m_vItemDescription.size();i++)
		if (!strcmp(m_vItemDescription[i]->pszItemName,szItemName)) return m_vItemDescription[i]->pInvSlotPict;
	return NULL;
}
extern int g_weaponselect;
void CMODTaskPanel::ButtonActionEquipUse()
{	
	    if (m_pCurrentButton->IsSlotEmpty() || m_pszCurrentSelectedHotkeyItem == m_pCurrentButton->ReturnSlotItemName()) return;
		m_pszCurrentSelectedHotkeyItem = m_pCurrentButton->ReturnSlotItemName();
		gEngfuncs.pfnClientCmd(m_pCurrentButton->ReturnSlotItemName());
		DropAllSelection();
		NullCurrentButton();
		//HideInventory();
}
void CMODTaskPanel::ButtonActionDrop()
{
	//char sz[255];
	//sprintf(sz,"vgui button action drop is %s\n",m_pCurrentButton->ReturnSlotItemName());
	//gEngfuncs.pfnConsolePrint(sz);
	if (m_pCurrentButton->IsSlotEmpty() || !(m_pCurrentButton->GetSpecialFlags() & SPF_CANDROP)) return;
	if (m_pszCurrentSelectedHotkeyItem == m_pCurrentButton->ReturnSlotItemName() ) m_pszCurrentSelectedHotkeyItem = NULL;
	for (int i=0;i<3;i++)
		if (m_vQuickSlots[i]->ReturnSlotItemName() == m_pCurrentButton->ReturnSlotItemName())
			m_vQuickSlots[i]->ClearSlot();
	char sz[255];
	sprintf(sz,"drop %s\n",m_pCurrentButton->ReturnSlotItemName());
	gEngfuncs.pfnClientCmd(sz);
	//gEngfuncs.pfnConsolePrint(sz);
	m_pCurrentButton->ClearSlot();
	DropAllSelection();
	NullCurrentButton();
	//HideInventory();
}
int CMODTaskPanel::LoadQSInventory(int q1, int q2, int q3)
{
	char ss[255];
	sprintf(ss,"%s%i%i%i\n","INVENTORY RESTORE: here we got",q1,q2,q3);
	gEngfuncs.pfnConsolePrint(ss);
	if (q1<7) m_vQuickSlots[0]->AssignSlot(m_vBackpackSlots[0],true);
	if (q2<7) m_vQuickSlots[1]->AssignSlot(m_vBackpackSlots[0],true);
	if (q3<7) m_vQuickSlots[2]->AssignSlot(m_vBackpackSlots[0],true);
	return 1;

	
	//must be called only once after game saverestore. its clears all of current data and places new instead 
/*	BEGIN_READ();
	char tmp[255];
	int j;
	for (int i=0;i<3;i++)
	{	
		tmp=READ_STRING();
		j=READ_SHORT;
		AddItem(tmp,0,0,j);
	}

*/
	
}


void CMODTaskPanel::SaveInventory()
{
	/*we store just hotkeys, because all other will be restored from other messages*/
	char invs[255];
	int a = 0;
	sprintf(invs,"%s","invqs");
	for (int i=0;i<3;i++)
	{
		a = m_vQuickSlots[i]->ReturnSlotInternalNumber();
		sprintf(invs+strlen(invs),"%i",(a>=0)?a:7);
	}
	gEngfuncs.pfnClientCmd(invs);
	
	/*
	//to store whole inventory on a server
	char invs[255];
	sprintf(invs,"%s","invs");
	//gEngfuncs.pfnConsolePrint(invs);
	for (int i=0;i<6;i++)
		if (!m_vBackpackSlots[i]->IsSlotEmpty())
		sprintf(invs+strlen(invs),"%i%i",m_vBackpackSlots[i]->ItemKind,m_vBackpackSlots[i]->ReturnSlotItemId());
		else sprintf(invs+strlen(invs),"%i%i",-1,-1);
	for (int i=0;i<3;i++)
		if (!m_vQuickSlots[i]->IsSlotEmpty())
		sprintf(invs+strlen(invs),"%i",m_vQuickSlots[i]->ReturnSlotItemId());
		else sprintf(invs+strlen(invs),"%i%i",-1,-1);
	gEngfuncs.pfnConsolePrint("Inv save some\n");
	gEngfuncs.pfnConsolePrint(invs);*/
	
}
/*
void CMODTaskPanel::LoadCurTasks(char *file)
{
	
	//if (IsTasksLoaded()) m_vTasks.clear();
	return; // disable this shit if u want proceed
	char *pfile = NULL;
	pfile = (char*)gEngfuncs.COM_LoadFile(file,5,NULL);
	if (!pfile) { gEngfuncs.pfnConsolePrint("mod_task_init: can not load an task file\n"); return; };
	char *ptext = pfile;
	bool begbl = 0;
	char token[1024];
	while (ptext)
	{
		ptext = gEngfuncs.COM_ParseFile(ptext,token);	
	}
	TiXmlDocument base_xml;
	base_xml.Parse(pfile);
	gEngfuncs.COM_FreeFile(pfile);
	TiXmlHandle base_xml_handle(&base_xml);
	TiXmlElement *pElement;
	TiXmlHandle hRoot(0);
	pElement = base_xml_handle.FirstChildElement("tasks").ToElement();
	if (!pElement)
	{
		gEngfuncs.pfnConsolePrint("mod_task_init: can not find root node TASKS");
		return;
	}
	hRoot = TiXmlHandle(pElement);
	for (pElement=hRoot.FirstChildElement("task").ToElement();pElement;pElement=pElement->NextSiblingElement("task"))
	{
		gEngfuncs.pfnConsolePrint("mod_task_init: has got a task\n");
		const char* txt = pElement->FirstChildElement("text")->ToElement()->GetText();
		gEngfuncs.pfnConsolePrint("mod_task_init: task text is ");
		gEngfuncs.pfnConsolePrint(txt);
		gEngfuncs.pfnConsolePrint("\n");
		m_vTasks.push_back((char*)txt);
	}
	SetCurTask(0); //for test only
	
}

bool CMODTaskPanel::IsTasksLoaded()
{
	return true;//m_vTasks.size()!=0;
}

void CMODTaskPanel::SetCurTask(int ind)
{
	if (!IsTasksLoaded()) gEngfuncs.pfnConsolePrint("mod_task_panel: can not set new task because m_vTasks is NULL\n");
	else {
		m_iCurTask = ind;
		m_hTaskText->setText(m_vTasks[ind]);
	}
}

void CMODTaskPanel::UnloadTasks()
{


}
*/
/*
CMODInventorySlot::CMODInventorySlot(const char* text,int x,int y,int wide,int tall,bool bNoHighlight,bool bFlat,e_inv_slotkind slotkind,e_inv_actions act) : CommandButton(text,x,y,wide,tall,bNoHighlight,bFlat)
{
	setPaintBackgroundEnabled(false);
	m_bLinkTo = NULL;
}
bool CMODInventorySlot::AssignSlot(char *szWeaponName, int itk, int fl, int id)
{
	m_pszWeaponName = szWeaponName;
	ItemKind = itk;
	m_iSpecialFlags = fl;
	m_iId = id;
	return true;
}
BitmapTGA* CMODInventorySlot::ReturnSlotPicture(int slp) { switch (slp) { case SLP_ITEM: return (SlotKind==INV_SLK_BACKPACK)?(GetParentInv()->GetItemSPictInfo(m_pszWeaponName)):m_bLinkTo->ReturnSlotPicture(slp); break; case SLP_DESC: return (SlotKind==INV_SLK_BACKPACK)?(GetParentInv()->GetItemDPictInfo(m_pszWeaponName)):m_bLinkTo->ReturnSlotPicture(slp); break; default: return NULL; break; }; };

void CMODInventorySlot::paint()
{
	drawSetColor(100, 100, 200, 100);
	//if (m_pSlotPicture) m_pSlotPicture->doPaint(this); else if (!m_pSlotPicture && SlotKind < 31 ) drawFilledRect(0,0,getWide(),getTall());
	if (SlotKind==INV_SLK_BACKPACK)
		{
			if (GetParentInv()->GetItemSPictInfo(m_pszWeaponName)) (GetParentInv()->GetItemSPictInfo(m_pszWeaponName))->doPaint(this); 
			else drawFilledRect(0,0,getWide(),getTall());
		}
	if ((SlotKind==INV_SLK_HOTKEY) && (m_bLinkTo!=NULL))
		{ 
			if (m_bLinkTo->ReturnSlotPicture(SLP_ITEM)) m_bLinkTo->ReturnSlotPicture(SLP_ITEM)->doPaint(this); 
			else drawFilledRect(0,0,getWide(),getTall()); 
		}
	else  if (SlotKind==INV_SLK_HOTKEY) drawFilledRect(0,0,getWide(),getTall());
	if (m_iPaintFlags & IPF_YELLOWRECT)
	{
		drawSetColor(255, 255, 0, 0);
		drawOutlinedRect(0,0,getWide(),getTall());
	};
	if (m_iPaintFlags & IPF_GREENRECT)
	{
		drawSetColor(0, 255, 0, 0);
		drawOutlinedRect(0,0,getWide(),getTall());
	};
	if (m_iPaintFlags & IPF_REDRECT)
	{
		drawSetColor(255, 0, 0, 0);
		drawOutlinedRect(0,0,getWide(),getTall());
	};
}
void CMODInventorySlot::internalMousePressed(vgui::MouseCode code)
{
	int inv_act = ((CMODTaskPanel*)getParent())->GetDoWhat();
	if ( inv_act == INV_ACT_NULL ) 
	{
		((CMODTaskPanel*)getParent())->SetDoWhat(SlotCmd);
		((CMODTaskPanel*)getParent())->SetCurrentButton(this);
		SetSelectionFrame();
	} else switch ( inv_act )
	{
		case INV_ACT_ITEM_WAITS_ACTION: //item waits action
			if ( SlotCmd == INV_ACT_ITEM_WAITS_ACTION ) //just another item slot
			{
			    ((CMODTaskPanel*)getParent())->DropAllSelection();
				((CMODTaskPanel*)getParent())->SetCurrentButton(this);
				SetSelectionFrame();
			}
			if ( SlotCmd == INV_ACT_HOTK_WAITS_ITEM ) //hotkey slot 
			{
				QuickslotAssign(((CMODTaskPanel*)getParent())->GetCurrentButton());
			};
			if ( SlotCmd == INV_ACT_COMD_WAITS_EQUIP ) //equip/use button 
			{
				((CMODTaskPanel*)getParent())->ButtonActionEquipUse();
			};


			if ( SlotCmd == INV_ACT_COMD_WAITS_DROP) // drop button
			{
				((CMODTaskPanel*)getParent())->ButtonActionDrop();
			};
			
			break;
		case INV_ACT_HOTK_WAITS_ITEM:
			if ( SlotCmd == INV_ACT_HOTK_WAITS_ITEM ) //just another hotkey slot
			{
			    ((CMODTaskPanel*)getParent())->DropAllSelection();
				((CMODTaskPanel*)getParent())->SetCurrentButton(this);
				SetSelectionFrame();
			} 
			if ( SlotCmd == INV_ACT_ITEM_WAITS_ACTION ) //backpack slot
			{
				((CMODTaskPanel*)getParent())->GetCurrentButton()->QuickslotAssign(this);
				((CMODTaskPanel*)getParent())->DropAllSelection();
				((CMODTaskPanel*)getParent())->MakeCurrentActionsNull();
			}
			if ( SlotCmd>=3 ) //other buttons
			{
				((CMODTaskPanel*)getParent())->DropAllSelection();
				((CMODTaskPanel*)getParent())->SetCurrentButton(this);
				((CMODTaskPanel*)getParent())->SetDoWhat(SlotCmd);
				SetSelectionFrame();
			}
			break;
		case INV_ACT_COMD_WAITS_EQUIP: // equip/use button
			if ( SlotCmd>=3 ) //other buttons
			{
				((CMODTaskPanel*)getParent())->DropAllSelection();
				((CMODTaskPanel*)getParent())->SetCurrentButton(this);
				((CMODTaskPanel*)getParent())->SetDoWhat(SlotCmd);
				SetSelectionFrame();
			}
			if ( SlotCmd == INV_ACT_ITEM_WAITS_ACTION )
			{
				((CMODTaskPanel*)getParent())->SetCurrentButton(this);
				((CMODTaskPanel*)getParent())->ButtonActionEquipUse();
			}
			break;
		//must include unite here

		case INV_ACT_COMD_WAITS_DROP:   //drop button
			if ( SlotCmd>=3 ) //other buttons
			{
				((CMODTaskPanel*)getParent())->DropAllSelection();
				((CMODTaskPanel*)getParent())->SetCurrentButton(this);
				((CMODTaskPanel*)getParent())->SetDoWhat(SlotCmd);
				SetSelectionFrame();
			}
			if ( SlotCmd == INV_ACT_ITEM_WAITS_ACTION ) // an backpack slot
			{
				((CMODTaskPanel*)getParent())->SetCurrentButton(this);
				((CMODTaskPanel*)getParent())->ButtonActionDrop();
			}
			break;


	};
}
void CMODInventorySlot::internalMouseDoublePressed(vgui::MouseCode code)
{
	if (SlotKind == INV_SLK_BACKPACK)
	{
		if (IsSlotEmpty() || m_pszWeaponName == ((CMODTaskPanel*)getParent())->GetSelectedHotkeyItem() ) return;
		((CMODTaskPanel*)getParent())->SetSelectedHotkeyItem(m_pszWeaponName);
		gEngfuncs.pfnClientCmd(m_pszWeaponName);
		((CMODTaskPanel*)getParent())->DropAllSelection();
		((CMODTaskPanel*)getParent())->HideInventory();
	};
	if (SlotKind == INV_SLK_HOTKEY)
	{
		QuickslotClear();
	}
}
void CMODInventorySlot::internalCursorEntered() { ((CMODTaskPanel*)getParent())->SetDescriptionImage(GetParentInv()->GetItemDPictInfo(ReturnSlotItemName())); };
void CMODInventorySlot::internalCursorExited()  { ((CMODTaskPanel*)getParent())->SetDescriptionImage(NULL); };
*/