#ifndef MOD_TASKPANEL_H
#define MOD_TASKPANEL_H
#include <vector>
using namespace vgui;
enum e_inv_slotkind
{
	INV_SLK_NULL = 0,
	INV_SLK_BACKPACK = 1,
	INV_SLK_HOTKEY = 20,
	INV_SLK_BUT_EQUIP = 31,
	INV_SLK_BUT_UNITE = 32,
	INV_SLK_BUT_DROP = 33,
	INV_SLK_BUT_DOUBLEEQ = 34,
	INV_SLK_BUT_NOTES = 35
};
enum e_inv_itemkind
{
	INV_ITK_WEAPON = 0,
	INV_ITK_ITEM
};
enum e_inv_actions
{
	INV_ACT_NULL = 0,
	INV_ACT_HOTK_WAITS_ITEM,
	INV_ACT_ITEM_WAITS_ACTION,
	INV_ACT_COMD_WAITS_EQUIP,
	INV_ACT_COMD_WAITS_UNITE,
	INV_ACT_COMD_WAITS_DROP,
	INV_ACT_COMD_WAITS_DWEQ_1,
	INV_ACT_COMD_NOTES,
	INV_ACT_COMD_WAITS_UNITE_2,
	INV_ACT_COMD_WAITS_DWEQ_2
	
};
enum e_inv_spf 
{ 
	SPF_CANDROP = 3
};
struct s_inv_item
{
	char pszItemName[255];
	BitmapTGA* pDescPicture;
	BitmapTGA* pInvSlotPict;
};
/*paint flags*/
#define IPF_YELLOWRECT		1<<0
#define IPF_GREENRECT		1<<1
#define IPF_REDRECT			1<<2
/*end paint flags*/
/*what slot picture do we want?*/
#define SLP_ITEM	1
#define SLP_DESC	2

class CMODInventorySlotBase : public CommandButton 
{
protected:
	int m_iInternalNumber; /*position in parent vector*/
	byte m_iPaintFlags; //ipf defines to here
	int m_iSlotKind; /* e_inv_slotkind - backpack ( 2 types ) or button */ 
	int m_iSlotCmd; /* e_inv_action - what to do when press this button */
	int m_iItemKind; /* e_inv_itemkind - is item a weapon or ordinary thing */
public:
	CMODInventorySlotBase(int kind,int cmd) : CommandButton("",0,0,0,0,false,true) { m_iSlotKind = kind; m_iSlotCmd = cmd; setPaintBackgroundEnabled(false); };
	CMODTaskPanel* GetParentInv() { return (CMODTaskPanel*)getParent(); };
	virtual bool AssignSlot(char *szwn, int iid = 0, int spf = 0) { return true; };
	virtual bool AssignSlot(CMODInventorySlotBase* bb, bool doForce = false) { return true; };
	virtual bool ClearSlot() { return true; };
	virtual char* ReturnSlotItemName() { return NULL; };
	virtual int	ReturnSlotItemId() { return -1; };
	virtual int ReturnSlotInternalNumber() { return m_iInternalNumber; };
	virtual BitmapTGA*	ReturnSlotPicture(int slp) { return NULL; };
	int ReturnSlotKind() { return m_iSlotKind; };
	int ReturnSlotCmd() { return m_iSlotCmd; };
	int ReturnItemKind() { return m_iItemKind; };
	bool SetPos (int x, int y) { setPos(x,y); return 1; };
	bool SetSize(int w, int h) { setSize(w,h); return 1; }; //99x99 for slot picture, other for different meanings
	void SetIntNum(int i) { m_iInternalNumber = i; }; 
	void ClearSelectionFrame() { m_iPaintFlags = 0; }; //clears all paint flags, so item/button will be displayed normally
	virtual void SetSelectionFrame() { return; };
	virtual bool IsSlotEmpty() { return FALSE; };
	virtual int GetSpecialFlags() { return 0; };
	//void PrintCurrentState() { char sz[255]; sprintf(sz,"CurrentState\nActiveButtonKind:%i",GetParentInv()->GetCurrentKind()); gEngfuncs.pfnConsolePrint(sz); };
};
class CMODInventorySlotBackpack : public CMODInventorySlotBase
{
private:
	char* m_pszItemName;
	int m_iId;
	int m_iSpecialFlags;
public:
	CMODInventorySlotBackpack(int w,int h);
	virtual bool AssignSlot(char *szwn, int iid = 0, int spf = 0);
	virtual bool ClearSlot() { m_pszItemName = NULL; m_iId = -1; return true; };
	virtual char* ReturnSlotItemName() { return m_pszItemName; } ;
	virtual int	ReturnSlotItemId() { return m_iId; };
	virtual BitmapTGA*	ReturnSlotPicture(int slp);
	virtual  void SetSelectionFrame() { m_iPaintFlags |= IPF_YELLOWRECT; };
	virtual bool IsSlotEmpty() { return m_pszItemName==NULL; };
	virtual int GetSpecialFlags() { return m_iSpecialFlags; };
	virtual void paint();
	virtual void internalMousePressed(vgui::MouseCode code);
	//virtual void internalMouseDoublePressed(vgui::MouseCode code); no doublepress for now 
	virtual void internalCursorEntered();
	virtual void internalCursorExited();
};
class CMODInventorySlotQuick: public CMODInventorySlotBase
{
private:
	CMODInventorySlotBackpack* m_bLinkTo;
public:
	CMODInventorySlotQuick(int w,int h);
	virtual bool AssignSlot(CMODInventorySlotBase* bb, bool doForce = false);
	virtual bool ClearSlot() { m_bLinkTo = NULL; return true; };
	virtual char* ReturnSlotItemName() { if (!m_bLinkTo) return NULL; else return m_bLinkTo->ReturnSlotItemName(); } ;
	virtual int	ReturnSlotItemId() { if (!m_bLinkTo) return -1; else return m_bLinkTo->ReturnSlotItemId(); };
	virtual BitmapTGA*	ReturnSlotPicture(int slp) { if (!m_bLinkTo) return NULL; else return m_bLinkTo->ReturnSlotPicture(slp); };
	virtual int ReturnSlotInternalNumber() { if (!m_bLinkTo) return -1; else return m_bLinkTo->ReturnSlotInternalNumber(); };
	virtual void SetSelectionFrame() { m_iPaintFlags |= IPF_GREENRECT; };
	virtual bool IsSlotEmpty() { return m_bLinkTo==NULL; };
	virtual int GetSpecialFlags() { return m_bLinkTo->GetSpecialFlags(); };
	virtual void paint();
	virtual void internalMousePressed(vgui::MouseCode code);
	virtual void internalMouseDoublePressed(vgui::MouseCode code) { ClearSlot(); }
	//virtual void internalCursorEntered(); 
	//virtual void internalCursorExited();
};
class CMODInventorySlotButton: public CMODInventorySlotBase
{
public:
	CMODInventorySlotButton(int k,int c); //473,99
	virtual void SetSelectionFrame() { m_iPaintFlags |= IPF_REDRECT; };
	virtual void paint();
	//virtual void internalMousePressed(vgui::MouseCode code);
};
class CMODTaskPanel : public Panel
{
private:
	BitmapTGA *m_pBackground;
	BitmapTGA *m_pInvBackground;
	std::vector<CMODInventorySlotBackpack*> m_vBackpackSlots;
	std::vector<CMODInventorySlotQuick*> m_vQuickSlots;
	std::vector<CMODInventorySlotButton*> m_vActionButtons;
	ImagePanel *m_pItemImage;
	CMODInventorySlotBase* m_pCurrentButton; /* current button clicked and waiting for action */
	std::vector<s_inv_item*> m_vItemDescription;
	char* m_pszCurrentSelectedHotkeyItem;
	void SaveInventory();
public:
	CMODTaskPanel(int x, int y, int wide, int tall);
	virtual void paint();
	void SetCurrentButton(CMODInventorySlotBase* butt) { if (m_pCurrentButton) m_pCurrentButton->ClearSelectionFrame(); m_pCurrentButton = butt; };
	CMODInventorySlotBase* GetCurrentButton() { return m_pCurrentButton; };
	int GetCurrentAction() { if (m_pCurrentButton) return m_pCurrentButton->ReturnSlotCmd(); else return INV_ACT_NULL; };
	int GetCurrentKind() { if (m_pCurrentButton) return m_pCurrentButton->ReturnSlotKind(); else return INV_SLK_NULL; }; 
	char* GetSelectedHotkeyItem() { return m_pszCurrentSelectedHotkeyItem; };
	void SetSelectedHotkeyItem(char* szItemName) { m_pszCurrentSelectedHotkeyItem = szItemName; }; 
	BitmapTGA* GetItemSPictInfo(char* szItemName);
	BitmapTGA* GetItemDPictInfo(char* szItemName);
	void SetDescriptionImage(BitmapTGA* d) { m_pItemImage->setImage(d); };
	bool LoadInventoryXml(); //loads an info about weapons and all items to array, must be called once
	int	 GetFreeSlot(); //gets free slot, -1 if none. possible remove if all inv on server?
	bool AddItem(char* szItemName, int itk = 0, int fl = 0, int id = 0 ); //add an item to client side inv
	bool ShowInventory() { setVisible(true);  gViewPort->UpdateCursorState(); };
	void HideInventory() { NullCurrentButton(); DropAllSelection(); SaveInventory(); setVisible(false); gViewPort->UpdateCursorState(); };
	int LoadQSInventory( int q1, int q2, int q3 ); //called everytime when restore called on server
	bool SelectSlot(int i); // selects 1st 2nd 3rd wpn
	virtual void internalMousePressed(vgui::MouseCode code) { NullCurrentButton(); DropAllSelection(); };
	/*buttons actions*/
	void ButtonActionEquipUse();
	void ButtonActionUnite() {}; //blank, will be implemented in future releases
	void ButtonActionDrop();
	void ButtonActionDoubleWeild() {}; // as actionunite
	void ButtonActionNotes();


	void NullCurrentButton() { m_pCurrentButton = NULL; };
	void DropAllSelection() { for (int i=0;i<6;i++) m_vBackpackSlots[i]->ClearSelectionFrame(); for (int i=0;i<3;i++) m_vQuickSlots[i]->ClearSelectionFrame(); for (int i=0;i<5;i++) m_vActionButtons[i]->ClearSelectionFrame(); }; //clears all selection on every item/button
	void ClearAllSlots() { for (int i=0;i<6;i++) m_vBackpackSlots[i]->ClearSlot(); for (int i=0;i<3;i++) m_vQuickSlots[i]->ClearSlot(); m_pszCurrentSelectedHotkeyItem = NULL; };
	void GlobalInvReset() { ClearAllSlots(); DropAllSelection(); NullCurrentButton(); m_pszCurrentSelectedHotkeyItem = NULL; }; //clears all slots and resets inventory to blank
	//void LoadCurTasks(char* file);
	//bool IsTasksLoaded();
	//void SetCurTask(int ind);
	//void UnloadTasks();
};












#endif
